<?php
/**
 * @package FASTSOCIALSHARE
 * @author Joomla! Extensions Store
 * @copyright (C) 2013 - Joomla! Extensions Store
 * @license GNU/GPLv2 http://www.gnu.org/licenses/gpl-2.0.html  
 */

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die();

class plgGMapFPFastSocialShare extends JPlugin {

	protected $autoloadLanguage = true;
	private $content ="";
	

	/*public function onGMapFPPrepareForm($form, $data)
	{
	}*/
	public function onGMapFPAfterTitle($context, &$row, &$params, $page=0)
	{
		if($this->params->get('position', 0) == 0) {
			$this->MakeContent($context, $row, $params);
			return $this->content;
		}
		return;
	}
	public function onGMapFPAfterIcon($context, &$row, &$params, $page=0){
		if($this->params->get('position', 0) == 1) {
			$this->MakeContent($context, $row, $params);
			return $this->content;
		}
		return;
	}
	
	public function onContentPrepare($context, &$article, &$params, $page=0) {
		if($this->params->get('position', 0) != 2) {
			return;
		}
		
		$app = JFactory::getApplication();
		$input = $app->input;
		/* @var $app JApplication */
		if ($app->isAdmin()) {
			return;
		}

		// Check if article GMapFP
		if ($input->get('option')!='com_gmapfp' || $input->get('layout')!='article') {
			$article->text = str_replace('{fastsocialsharegmapfp}', '', $article->text);
			return;
		}
		
		$doc = JFactory::getDocument();
		/* @var $doc JDocumentHtml */
		$docType = $doc->getType();
	
		// Check document type
		if (strcmp("html", $docType) != 0) {
			$article->text = str_replace('{fastsocialsharegmapfp}', '', $article->text);
			return;
		}
		
		// Output JS APP nel Document
		if(JRequest::getCmd('print')) {
			$article->text = str_replace('{fastsocialsharegmapfp}', '', $article->text);
			return;
		}
		if (!isset($this->params)) {
			$article->text = str_replace('{fastsocialsharegmapfp}', '', $article->text);
			return;
		}
	
		$foundReplace = strstr($article->text, '{fastsocialsharegmapfp}');
		if (!$foundReplace) {
			return;
		}

		$article->text = str_replace('{fastsocialsharegmapfp}', $this->content, $article->text);
		return;
	}
	


	private function getContent(&$article, &$params) {

		$doc = JFactory::getDocument();
		/* @var $doc JDocumentHtml */

		$doc->addStyleSheet(JURI::root() . "plugins/gmapfp/fastsocialshare/style/style.css");

		$uriInstance = JURI::getInstance();
		
		if(!class_exists('GMapFPHelperRoute')) {
			include_once JPATH_SITE . '/components/com_gmapfp/helpers/route.php';
		}
		$url = JRoute::_(GMapFPHelperRoute::getArticleRoute($article->id, $article->catid), false);
		
		$root = rtrim($uriInstance->getScheme() . '://' . $uriInstance->getHost(), '/');
		$url = $root . $url;
		$title = htmlentities($article->title, ENT_QUOTES, "UTF-8");

		$html = $this->getFacebookLike($this->params, $url, $title);
		$html .= $this->getFacebookShareMe($this->params, $url, $title);
		$html .= $this->getTwitter($this->params, $url, $title);
		$html .= $this->getLinkedIn($this->params, $url, $title);
		$html .= $this->getPinterest($this->params, $url, $title);
		
		return '<div class="gmapfp_fastsocialshare_container">' . $html . '<div class="gmapfp_fastsocialshare_clearer"></div></div>';
	}

	private function getFacebookLike($params, $url, $title) {
		static $fbRoot = '<div id="fb-root"></div>';
		
		$html = "";
		$appID = null;
		if ($params->get("facebookLikeButton", true)) {
			$layout = $params->get("facebookLikeType", "button_count");
			if (strcmp("box_count", $layout) == 0) {
				$height = "80";
			} else {
				$height = "25";
			}
	
			$html = '<div class="gmapfp_fastsocialshare-share-fbl ' . $layout . '">';
	
			if ($params->get("facebookLikeAppId")) {
				$appID = '&appId=' . $params->get("facebookLikeAppId");
			}
			
			$html .= <<<JS
						$fbRoot
						<script>
						var loadAsyncDeferredFacebook = function() {
							(function(d, s, id) {
							  var js, fjs = d.getElementsByTagName(s)[0];
							  if (d.getElementById(id)) return;
							  js = d.createElement(s); js.id = id;
							  js.src = "//connect.facebook.net/{$this->langTag}/sdk.js#xfbml=1&version=v2.5$appID";
							  fjs.parentNode.insertBefore(js, fjs);
							}(document, 'script', 'facebook-jssdk'));
						}

				  		if (window.addEventListener)
							window.addEventListener("load", loadAsyncDeferredFacebook, false);
						else if (window.attachEvent)
							window.attachEvent("onload", loadAsyncDeferredFacebook);
						else
					  		window.onload = loadAsyncDeferredFacebook;
						</script>
JS;
			$html .= '
				<div class="fb-like"
					data-href="' . $url . '"
					data-layout="' . $layout . '"
                	data-width="' . $params->get("facebookLikeWidth", "450") . '"
					data-action="' . $params->get("facebookLikeAction", 'like') . '"
					data-show-faces="' . $params->get("facebookLikeShowfaces", 'true') . '"
					data-share="false">
				</div>';
			$html .= '</div>';
		}
	
		$fbRoot = null;
		return $html;
	}
	
	private function getFacebookShareMe($params, $url, $title) {
		// Get the number of shares for this URL
		$sharesCounterCode = null;
		if ($params->get("facebookShareMeCounter", 0)) {
			$encodedUrl = rawurlencode($url);
			$sharesJsonData = file_get_contents("https://graph.facebook.com/?id=" . $encodedUrl);
			if($sharesJsonData) {
				$sharesJsonData = json_decode($sharesJsonData);
				if(isset($sharesJsonData->share)) {
					$sharesObject = $sharesJsonData->share;
					$numberOfShares = $sharesObject->share_count;
					$sharesCounterCode = '<div class="fbshare_container_counter">
											<div class="pluginCountButton pluginCountNum">
												<span>
													<span class="pluginCountTextConnected">' . $numberOfShares . '</span>
												</span>
											</div>
											<div class="pluginCountButtonNub">
												<s></s>
												<i></i>
											</div>
										 </div>';
				}
			}
		}
		
		$html = "";
		if ($params->get("facebookShareMeButton", true)) {
			$colorText = $params->get("facebookShareMeBadgeText", "C0C0C0");
			$badgeColor = $params->get("facebookShareMeBadge", "CC00FF");
			$badgeLabel = $params->get("facebookShareMeBadgeLabel", "Share");
			$encodedUri = rawurlencode($url);
			$html = <<<JS
						<div id="fbshare_container" class="gmapfp_fastsocialshare-share-fbsh">
    					<a style="text-decoration:none; border-radius: 2px; padding:2px 5px; font-size:14px; background-color:#$badgeColor; color:#$colorText !important;" onclick="window.open('http://www.facebook.com/sharer/sharer.php?u=$encodedUri','fbshare','width=480,height=100')" href="javascript:void(0)"><span style="text-decoration:none; font-weight:bold; font-size:14px;margin-right:4px;">f</span>$badgeLabel</a>
    					$sharesCounterCode
						</div>
JS;
		}
		return $html;
	}
	
	private function getTwitter($params, $url, $title) {
		$twitterCounter = $params->get("twitterCounter", 'none');
		$twitterName = $params->get("twitterName", '');
		$twitterSize = null;
		if($params->get("twitterSize", 0)) {
			$twitterSize = 'data-size="large"';
		}
		
		$html = "";
		if($params->get("twitterButton", true)) {
			$html = <<<JS
						<div class="gmapfp_fastsocialshare-share-tw">
						<a href="https://twitter.com/share" class="twitter-share-button" $twitterSize data-text="$title" data-count="$twitterCounter" data-via="$twitterName" data-url="$url" data-lang="{$this->langStartTag}">Tweet</a>
						</div>
						<script>
							var loadAsyncDeferredTwitter =  function() {
	            						var d = document;
	            						var s = 'script';
	            						var id = 'twitter-wjs';
					            		var js,fjs=d.getElementsByTagName(s)[0],p=/^http:/.test(d.location)?'http':'https';if(!d.getElementById(id)){
						        		js=d.createElement(s);js.id=id;js.src=p+'://platform.twitter.com/widgets.js';fjs.parentNode.insertBefore(js,fjs);}
					        		}
						
							if (window.addEventListener)
								window.addEventListener("load", loadAsyncDeferredTwitter, false);
							else if (window.attachEvent)
								window.attachEvent("onload", loadAsyncDeferredTwitter);
							else
								window.onload = loadAsyncDeferredTwitter;
						</script>
JS;
		}
		
		
		return $html;
	}

	private function getLinkedIn($params, $url, $title) {
		$language = "lang: " . $this->langTag;
		
		$html = "";
		if ($params->get("linkedInButton", true)) {
			$dataCounter = $params->get("linkedInType", 'right');
			$html = <<<JS
						<div class="gmapfp_fastsocialshare-share-lin">
						<script type="text/javascript">
							var loadAsyncDeferredLinkedin =  function() {
								var po = document.createElement('script');
								po.type = 'text/javascript';
								po.async = true;
								po.src = 'https://platform.linkedin.com/in.js';
								po.innerHTML = '$language';
								var s = document.getElementsByTagName('script')[0];
								s.parentNode.insertBefore(po, s);
							};
		
							 if (window.addEventListener)
							  window.addEventListener("load", loadAsyncDeferredLinkedin, false);
							else if (window.attachEvent)
							  window.attachEvent("onload", loadAsyncDeferredLinkedin);
							else
							  window.onload = loadAsyncDeferredLinkedin;
						</script>
						<script type="in/share" data-url="$url" data-counter="$dataCounter"></script>
						</div>
JS;
		}
	
		return $html;
	}
	
	private function getPinterest($params, $url, $title) {
		$html = "";
		if($params->get("pinterestButton", true)) {
			$html = <<<JS
						<div class="gmapfp_fastsocialshare-share-pinterest">
						<a href="//www.pinterest.com/pin/create/button/" data-pin-do="buttonBookmark"  data-pin-color="red"><img src="//assets.pinterest.com/images/pidgets/pinit_fg_en_rect_red_20.png" /></a>
						<script type="text/javascript">
							(function (w, d, load) {
							 var script, 
							 first = d.getElementsByTagName('SCRIPT')[0],  
							 n = load.length, 
							 i = 0,
							 go = function () {
							   for (i = 0; i < n; i = i + 1) {
							     script = d.createElement('SCRIPT');
							     script.type = 'text/javascript';
							     script.async = true;
							     script.src = load[i];
							     first.parentNode.insertBefore(script, first);
							   }
							 }
							 if (w.attachEvent) {
							   w.attachEvent('onload', go);
							 } else {
							   w.addEventListener('load', go, false);
							 }
							}(window, document, 
							 ['//assets.pinterest.com/js/pinit.js']
							));    
							</script>
						</div>
JS;
		}
	
			return $html;
	}
	

	public function MakeContent($context, &$article, &$params) {
		$app = JFactory::getApplication();
		$input = $app->input;
		$doc = JFactory::getDocument();

		// récupère les info du lieu
		$gmapfp_id = $input->getint('map_id');
		if (empty($gmapfp_id)) {
			$Itemid = $input->get('Itemid');
			$menu = $app->getMenu()->getActive();
			if(isset($menu->params) and property_exists($menu->params, 'get'))
				$gmapfp_id = $menu->params->get('id');
			else return;
		}
		
		$table = JTable::getInstance('gmapfp', 'GMapFPTable');
		$table->load($gmapfp_id);
		
		if (!isset($table) OR empty($table->id)) {
			return;
		}
	
		// Extract the first image from the article-entity/first article-entity text html for all extensions calling onContentPrepare
		if($table) {
			if($this->params->get('ogimage_detection', 1) && isset($table->img)) {
				$doc->setMetaData('og:image', '/images/gmapfp/'.$table->img);
			}
			if($this->params->get('ogtitle_detection', 1) && isset($table->nom)) {
				$doc->setMetaData('og:title', $table->nom);
			}
			if($this->params->get('ogdescription_detection', 1) && isset($table->introtext)) {
				$dots = JString::strlen($table->introtext) > 300 ? '...' : '';
				$description = JString::substr(strip_tags($table->introtext), 0, 300);
				$description = str_replace(PHP_EOL, '', $description);
				$description = str_replace('{fastsocialsharegmapfp}', '', $description);
				$description .= $dots;
				$doc->setMetaData('og:description', $description);
			}
		}
			
		$excludeArticles = $this->params->get('excludeArticles', array());
		if (!empty($excludeArticles)) {
			$excludeArticles = explode(',', $excludeArticles);
			JArrayHelper::toInteger($excludeArticles);
		}
	
		// Exluded categories
		$excludedCats = $this->params->get('excludeCats', array());
		if (!empty($excludedCats)) {
			$excludedCats = explode(',', $excludedCats);
			JArrayHelper::toInteger($excludedCats);
		}
	
		// Check exluded places
		$catids = explode(',', $table->catid);
		if (in_array($table->id, $excludeArticles) OR array_intersect($catids, $excludedCats)) {
			return "";
		}

		// Get plugin contents
		$article->id = $table->id;
		$article->catid = $table->catid;
		$article->title = $table->nom;
		$this->content = $this->getContent($article, $params);
	
		return;
	}
	
	/**
	 * Class Constructor
	 *
	 * @param object $subject The object to observe
	 * @param array  $config  An optional associative array of configuration settings.
	 * Recognized key values include 'name', 'group', 'params', 'language'
	 * (this list is not meant to be comprehensive).
	 * @since 1.5
	 */
	public function __construct(&$subject, $config = array()) {
		parent::__construct($subject, $config);
		$lang = JFactory::getLanguage();
		$locale = $lang->getTag();
		$this->langTag = str_replace("-", "_", $locale);
		$this->langStartTag = @array_shift(explode('-', $locale));

	}
}